// --- [xbee_api ] -----------------------------------------------------------
//
// tab = 3
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "ftd2xx.h"
#include <dos.h>
#include <time.h>
#include "ftdi.h"
#include "global.h"
#include "xbee_api.h"

#ifdef IS_CONIO2_LIB
	#include <conio2.h>
#endif
// ---------------------------------------------------------------------------
// die Targets 0 / 1 sind fr den Coordinator / Broadcast reserviert
// weitere Adressen knnen aus der Datei "xbee_adr.cfg" importiert werden.
unsigned char target_adr[DEVICES][8] = {
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,0x00},
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,0xFF}
};
unsigned char target_network_adr[DEVICES][2] = {
{0x00, 0x00},
{0xFF, 0xFE}
};
char api_cmd[100];                        // Platz um ein api_cmd aufzubauen

// ---------------------------------------------------------------------------
void add_return(char* txt);
void API_at_cmd(char * cmd, unsigned int cnt);
void API_remote_at_cmd_request(unsigned int i, char * cmd, unsigned int cnt);
void print_api_cmd(void);
void frame88 (unsigned char * data);
void frame8A (unsigned char * data);
void frame8B (unsigned char * data);
void frame90 (unsigned char * data);
void frame92 (unsigned char * data);
void frame95 (unsigned char * data);
void frame97 (unsigned char * data);

// ----------------------------------------------------------------------------
// Sendet ein AT-Command an das lokale Device - Frame 0x08
void API_at_cmd(char * cmd, unsigned int cnt)
{
int i, j;

api_cmd[0] = FIRST_CHR;
api_cmd[1] = 0;
api_cmd[3] = 0x08;                        // Frame Type 0x08

if (const_frame_id_0) api_cmd[4] = 0;
else
   {
   if (++frame_id == 0) frame_id++;       // Frame ID incrementieren, aber nicht 0
   last_frame_id = frame_id;
   api_cmd[4] = frame_id;                 // Frame ID
   }

i = 2;
j = 5;
while (i < cnt)                           // wegen mglicher abschlieender '0'
	{
 	api_cmd[j++] = cmd[i++];   				// das Kommando schreiben
	}

api_cmd[2] = i;                       		// die Lnge ohne Prfsumme schreiben
api_cmd[j] = checksum(api_cmd);

rs232_api_write(api_cmd);                // ATxx schreiben
if (verbosed == 2) print_api_cmd();           // die Bytefolge am Terminal ausgeben

}

// ----------------------------------------------------------------------------
// Sendet ein AT-Command an ein entferntes Device - Frame 0x17
void API_remote_at_cmd_request(unsigned int device, char * cmd, unsigned int cnt)
{
unsigned int i, j;

api_cmd[0] = FIRST_CHR;                   // der Header
api_cmd[1] = 0;
api_cmd[3] = 0x17;                        // Frame Type 0x17
if (const_frame_id_0) api_cmd[4] = 0;
else
   {
   if (++frame_id == 0) frame_id++;       // Frame ID incrementieren, aber nicht 0
   last_frame_id = frame_id;
   api_cmd[4] = frame_id;                 // Frame ID
   }
   
i = 0;
for (j = 5; j < 13; j++) api_cmd[j] =  target_adr[device][i++];
i = 0;
for (j = 13; j < 15; j++) api_cmd[j] = target_network_adr[device][i++];
api_cmd[j++] = 0x02;                      // apply changes on remote !!

i = 2;
//while (!(cmd[i] == 0))
while (i < cnt)
	{
 	api_cmd[j++] = cmd[i++];   				// das Kommando schreiben
	}

api_cmd[2] = i + 11;              			// die Lnge ohne Prfsumme schreiben
api_cmd[j] = checksum(api_cmd);           //

rs232_api_write(api_cmd);                // ATxx schreiben
if (verbosed == 2) print_api_cmd();           // die Bytefolge am Terminal ausgeben
}

// ----------------------------------------------------------------------------
// Sendet eine Bytefolge incl. Nullbytes - Frame 0x10
// daher muss die Anzahl der Bytes mit bergeben werden
void API_Tx_Request(unsigned int device, char * txt, unsigned int txt_len)
{
unsigned int i, j;

api_cmd[0] = FIRST_CHR;                   // der Header
api_cmd[1] = 0;
api_cmd[3] = 0x10;                        // Frame Type 0x1


if (const_frame_id_0) api_cmd[4] = 0;
else
   {
   if (++frame_id == 0) frame_id++;       // Frame ID incrementieren, aber nicht 0
   last_frame_id = frame_id;
   api_cmd[4] = frame_id;                 // Frame ID
   }

i = 0;
for (j = 5; j < 13; j++) api_cmd[j] =  target_adr[device][i++];
i = 0;
for (j = 13; j < 15; j++) api_cmd[j] = target_network_adr[device][i++];
api_cmd[j++] = 0x00;                      // Broadcast Radius
api_cmd[j++] = 0x00;                      // Options

i = 0;
while (txt_len--) api_cmd[j++] = txt[i++]; // Bytefolge schreiben
/*
while (!(txt[i] == 0)) api_cmd[j++] = txt[i++]; // den Text schreiben
*/

api_cmd[2] = i + 14;              			// die Lnge ohne Prfsumme schreiben
api_cmd[j] = checksum(api_cmd);           //

rs232_api_write(api_cmd);                 // das cmd senden
if (verbosed == 2) print_api_cmd();            // die Bytefolge am Terminal ausgeben
}

// ----------------------------------------------------------------------------
// zum Debuggen: hexadezimale Ausgabe eines API-Kommandos
// die Lnge wird dem Kommando entnommen
void print_api_cmd(void)
{
unsigned int i, end;

#ifdef IS_CONIO2_LIB
	textcolor(LIGHTCYAN);
#endif

end = api_cmd[2] + 3;                       // die Lnge des Kommandos
printf("\n");
for (i = 0; i <= end; i++) printf("%X ",(unsigned char) api_cmd[i]);
//if (test_checksum(api_cmd) == 1) printf(". crc ok"); else printf(". crc error");
if (test_checksum(api_cmd) == 0) printf(". crc error");
}

// ----------------------------------------------------------------------------
// addiert alle Bytes von Position 3 bis zum Byte vor der Prfsumme
// und subtrahiert das Ergebnis von 0xFF
char checksum(unsigned char * data)
{
unsigned char i = 0;
unsigned int end, j;
end = data[2] + (3 - 1);                 	// die Prfsumme nicht in die Prfsumme einschlieen

for (j = 3; j <= end; j++)                // die Prfsumme beginnt hinter der Lnge api_cmd[2]
	{
	i += (char) data[j];
	}
return(0xFF - i);                         // den Wert von 255 abziehen
}

// ----------------------------------------------------------------------------
// prft, ob die Summe aller Bytes == 255
// Die Summierung beginnt mit Byte[3] und schliet die Prfsumme ein!
int test_checksum(unsigned char * data)
{
unsigned int i, end;
unsigned char checksum = 0;               // als 8 Bit-Wert

end = data[2] + 3;                 // Prfsumme einbeziehen
for (i = 3; i <= end; i++) checksum+= data[i];
if (checksum  == 255) return 1; else return(-1);
}

// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x88 AT COMMAND RESPONSE im Detail aus
void frame88 (unsigned char * data)
{
unsigned int i, end;
char tmp[3] = {0,0,0};
end = data[2] + 3;
printf("\n\nFrame Type 0x88 - AT Command Response\n");
printf("\nFrame ID    : %X ", data[4]);
tmp[0] = data[5];
tmp[1] = data[6];
printf("\ncommand     : %s",tmp);
printf("\nstatus      : %X - ", data[7]);
if      (data[7] == 0x00) printf("OK");
else if (data[7] == 0x01) printf("ERROR");
else if (data[7] == 0x02) printf("Invalid Command");
else if (data[7] == 0x03) printf("Invalid Parameter");
else if (data[7] == 0x04) printf("Tx Failure");
printf("\ndata        : ");
for(i = 8; i < end; i++) printf("%X ", data[i]);
}


// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x8A MODEM STATUS im Detail aus
// der Frame hat eine feste Lnge
void frame8A (unsigned char * data)
{
printf("\n\nFrame Type 0x8A - Modem Status\n");
printf("\nstatus      : %X - ", data[4]);
if      (data[4] == 0x00) printf("Hardware reset");
else if (data[4] == 0x01) printf("Watchdog timer reset");
else if (data[4] == 0x02) printf("Joined network (routers and end device)");
else if (data[4] == 0x03) printf("Disassociated");
else if (data[4] == 0x06) printf("Coordinator started");
else if (data[4] == 0x07) printf("Network security key was updated");
else if (data[4] == 0x0D) printf("Voltage supply limit exceeded");
else if (data[4] == 0x10) printf("Key establishment complete");
else if (data[4] == 0x80) printf("Stack error");
}

// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x8B ZIGBEE TRANSMIT STATUS im Detail aus
void frame8B (unsigned char * data)
{
unsigned int i, end;
//char tmp[3] = {0,0,0};
end = data[2] + 3;
printf("\n\nFrame Type 0x8B - ZigBee Transmit Status\n");
printf("\nFrame ID         : %X ", data[4]);
printf("\nDestination16bit : ");
for (i = 5; i < 7; i++) printf("%X ", data[i]);
printf("\nTX Retry Count   : %X", data[7]);
printf("\nDelivery  Status : %X - ", data[8]);
if      (data[8] == 0x00) printf("Success");
else if (data[8] == 0x01) printf("MAC ACK Failure");
else if (data[8] == 0x02) printf("CCA Failure");
else if (data[8] == 0x15) printf("Invalid Destination Endpoint");
else if (data[8] == 0x21) printf("Network ACK Failure");
else if (data[8] == 0x22) printf("Not Joined to Network");
else if (data[8] == 0x23) printf("Self addressed");
else if (data[8] == 0x24) printf("Address not Found");
else if (data[8] == 0x25) printf("Route not Found");
else if (data[8] == 0x26) printf("Broadcast source failed to hear a neighbor relay the message");
else if (data[8] == 0x2B) printf("Invalid binding table index");
else if (data[8] == 0x2C) printf("Resource error lack of free buffers, timers etc.");
else if (data[8] == 0x32) printf("Resource error lack of free buffers, timers etc.");
else if (data[8] == 0x2B) printf("Invalid binding table index");
else if (data[8] == 0x74) printf("Data Payload too large");
else if (data[8] == 0x75) printf("Indirect message unrequested");
else printf("unknown");
printf("\nDiscovery Status : %X - ", data[9]);
if      ((data[9] & 0x0F) == 0x00) printf("No Discovery Overhead");
else if ((data[9] & 0x0F) == 0x01) printf("Address Discovery");
else if ((data[9] & 0x0F) == 0x02) printf("Route Discovery");
else if ((data[9] & 0x0F) == 0x03) printf("Address and Route Discovery");
if ((data[9] & 0xF0) == 0x40) printf(" - Extended timeout Discovery");

}

// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x90 ZIGBEE RECEIVE PACKET im Detail aus
// hier ist mglicherweise ein Fehler im Datenblatt, in der Lnge der 64-Bit Adresse
// noch nicht getestet !!!!!!!!!!!!!!!!!!!!!!
void frame90 (unsigned char * data)
{
unsigned int i, end;
end = data[2] + 3;
printf("\n\nFrame Type 0x90 - ZigBee Receive Packet\n");
printf("\nSource64bit : ");
for (i = 4; i < 12; i++) printf("%X ", data[i]);
printf("\nSource16Bit : ");
for (i = 12; i < 14; i++) printf("%X ", data[i]);
printf("\nRx-Options  : %X - ", data[14]);
if      (data[14] == 0x01) printf("Packet Acknowledged");
else if (data[14] == 0x02) printf("Packet was a broadcast packet");
else if (data[14] == 0x20) printf("Packet encrypted with APS encryption");
else if (data[14] == 0x40) printf("Packet was send from an end device");
printf("\nRx-Data     : ");
for(i = 15; i < end; i++) printf("%X ", data[i]);
}


// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x92 ZIGBEE IO DATA SAMPLE RX INDICATOR im Detail aus
void frame92 (unsigned char * data)
{
unsigned int i, end;
end = data[2] + 3;
printf("\n\nFrame Type 0x92 - ZigBee IO Data Sample Rx Indicator\n");
printf("\nSource64bit : ");
for (i = 4; i < 12; i++) printf("%X ", data[i]);
printf("\nSource16bit : ");
for (i = 12; i < 14; i++) printf("%X ", data[i]);
printf("\nRx-Options  : %X - ", data[14]);
if      (data[14] == 1) printf("Packet Acknowledged");
else if (data[14] == 2) printf("Packet was a broadcast packet");
printf("\nSamples     : %X", data[15]);
printf("\nDigCh.Mask  : hi: %X lo: %X", data[16], data[17]);
printf("\nAnaCh.Mask  : %X", data[18]);
printf("\ndata hi.lo  : ");
for (i = 19; i < end; i++)
   {
   printf("%X", data[i]);
   if((i % 2)) printf("."); else printf("  ");
   }
//printf("\ndata [ascii]: ");
//for (i = 19; i < end; i++) if (isprint((char)data[i])) printf("%c ", data[i]); else printf("_ ");
}

// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x95 NODE IDENTIFICATION INDICATOR im Detail aus
void frame95 (unsigned char * data)
{
unsigned int i, end;
end = data[2] + 3;
printf("\n\nFrame Type 0x95 - Node Identification Indicator\n");
printf("\nSource64bit : ");							// wer ist hier was ???
for (i = 4; i < 12; i++) printf("%X ", data[i]);
printf("\nSource16bit : ");
for (i = 12; i < 14; i++) printf("%X ", data[i]);
printf("\nRx-Options  : %X - ", data[14]);
if      (data[14] == 1) printf("Packet Acknowledged");
else if (data[14] == 2) printf("Packet was a broadcast packet");
printf("\nRemote16bit : ");						// wer ist hier was ???
for (i = 15; i < 17; i++) printf("%X ", data[i]);
printf("\nRemote64bit : ");
for (i = 17; i < 25; i++) printf("%X ", data[i]);
printf("\nNodeId$     : ");
i = 25;
while (data[i]) printf("%X ", data[i++]);
//printf("0 ");                             // den Terminator ausgeben
														// NI kann 20 Zeichen lang sein
i = end - 8;                              // hier wird vom Ende her zurckgerechnet
printf("\nParent Adr  : ");
printf("%X ", data[i++]);
printf("%X ", data[i++]);
printf("\nDevice Typ  : %X - ", data[i]);
if      (data[i] == 0x00) printf("Coordinator");
else if (data[i] == 0x01) printf("Router");
else if (data[i] == 0x02) printf("End device");
printf("\nSource Evt  : %X - ", data[++i]);
if      (data[i] == 0x01) printf("Pushbutton Event");
else if (data[i] == 0x02) printf("Joining Event");
else if (data[i] == 0x03) printf("Power Cycle Event");

printf("\nProfile ID  : ");
printf("%X ", data[++i]);
printf("%X ", data[++i]);

printf("\nManufac.ID  : ");
printf("%X ", data[++i]);
printf("%X ", data[++i]);
}

// ----------------------------------------------------------------------------
// Gibt die Daten des Frame Type 0x97 REMOTE COMMAND RESPONSE im Detail aus
void frame97 (unsigned char * data)
{
unsigned int i, end;
char tmp[3] = {0,0,0};
end = data[2] + 3;
printf("\n\nFrame Type 0x97 - Remote Command Response\n");
printf("\nFrame ID    : %X ", data[4]);
printf("\nRemote64bit : ");
for (i = 5; i < 13; i++) printf("%X ", data[i]);
printf("\nRemote16bit : ");
for (i = 13; i < 15; i++) printf("%X ", data[i]);
tmp[0] = data[15];
tmp[1] = data[16];
printf("\ncommand     : %s",tmp);
printf("\nstatus      : %X - ", data[17]);

if      (data[17] == 0x00) printf("OK");
else if (data[17] == 0x01) printf("ERROR");
else if (data[17] == 0x02) printf("Invalid Command");
else if (data[17] == 0x03) printf("Invalid Parameter");
else if (data[17] == 0x04) printf("Remote Command Transmission Failed");

printf("\ndata        : ");
for(i = 18; i < end; i++) printf("%X ", data[i]);
//printf("\ndata [ascii]: ");
//for(i = 18; i < end; i++)  if (isprint((char)data[i])) printf("%c ", data[i]); else printf("_ ");
}

// --- [eof ] ----------------------------------------------------------------
